;
; Init dummy data module
;
.segment "CODE_DUMMY"

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-
; What can be viewed by other modules
;
.export subInitAllDummyData

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; DEBUG code for dummy data
;
.import palette
.import sprData
.import background_bc

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-
; Import some zero pages variables used
; as parameters
;
.importzp zpCopySrcAdr

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-
; Include some useful symbolic constants,
; macros and headers files
;
.include "./src/inc/NES.inc"
.include "./src/common/utils.h"
.include "./src/inc/macro.inc"


;->BEGIN----------------------------------------------------------------------
; All the dummy data is initialization phase is done here
;
.proc subInitAllDummyData
	; Save palette address as a parameter then load it
	putSrcAdrInDest palette, zpCopySrcAdr
	jsr subLoadPalette
	
	; Save background data address as a parameter then load it
	putSrcAdrInDest background_bc, zpCopySrcAdr
	jsr subInitDummyBGDataInNT           
	
	; Save sprite data address as a parameter then load it
        putSrcAdrInDest sprData, zpCopySrcAdr
	jsr subInitDummySpriteData

	rts
.endproc
;-<END------------------------------------------------------------------------

	
;->BEGIN----------------------------------------------------------------------
; Test method that will load some sprite attribute data.
; uses: zpCopySrcAdr for the address of the sprite data
;
.proc subInitDummySpriteData
	ldy #0                ; Index for data, start at 0 for source and destination

@copyDummySprData:
        lda (zpCopySrcAdr),y  ; get data
        sta OAM,y             ; and store it
        
        iny                   ; Increase index
        cpy #32		      ; Counter, 32 bytes only for now
        
        bne @copyDummySprData ; While still some data to copy

	; Finally update SPR-RAM
	jsr subUpdateSprRam
	
	rts
.endproc
;-<END------------------------------------------------------------------------


;->BEGIN----------------------------------------------------------------------
; Now try to load BF data
; uses: zpCopySrcAdr for the address of the background data
;
.proc subInitDummyBGDataInNT
        lda PPU_STATUS        ; Reset latch

        lda #$20              ; Write NT $2000 at address register, high byte first
        sta PPU_ADDR  
        lda #$00
        sta PPU_ADDR 

        ; Init loop indexes
        ldy #$00              ; Y used as main loop
        ldx #$08              ; X used for pages (8 pages = $800 bytes, which is 2 nametables + attributes)
        
@copyBG:lda (zpCopySrcAdr),y  ; Store in A the next BG data
        sta PPU_DATA          ; store Y (bg data) in VRAM
        iny                   ; and increase counter
        
        bne @copyBG           ; While page is not over
        
        inc zpCopySrcAdr+1     ; Now switch to next page in temp variable
	dex                   ; Decrease page counter

	bne @copyBG           ; Jump if still some pages left
    
        rts
 .endproc
;-<END------------------------------------------------------------------------
